#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityMonsterGiftBoxCFG.h"
std::auto_ptr<M_ActivityMonsterGiftBoxCFG> M_ActivityMonsterGiftBoxCFG::msSingleton(nullptr);

int M_ActivityMonsterGiftBoxCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityMonsterGiftBoxCFGData* M_ActivityMonsterGiftBoxCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityMonsterGiftBoxCFGData>& M_ActivityMonsterGiftBoxCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityMonsterGiftBoxCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityMonsterGiftBoxCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityMonsterGiftBoxCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mIntegralItem = element->IntAttribute("IntegralItem");
		data.mIntegralCount = element->IntAttribute("IntegralCount");
		data.mArmsId = element->IntAttribute("ArmsId");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityMonsterGiftBoxCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMonsterGiftBoxCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityMonsterGiftBoxCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityMonsterGiftBoxCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityMonsterGiftBoxCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readInt(L, "IntegralItem", data.mIntegralItem);
		LuaCfgHelper::readInt(L, "IntegralCount", data.mIntegralCount);
		LuaCfgHelper::readInt(L, "ArmsId", data.mArmsId);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityMonsterGiftBoxCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMonsterGiftBoxCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityMonsterGiftBoxCFG* M_ActivityMonsterGiftBoxCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityMonsterGiftBoxCFG());
	}
	return msSingleton.get();
}

void M_ActivityMonsterGiftBoxCFG::Release()
{
	msSingleton.reset(nullptr);
}
